%define anolis_release 1

%bcond_without check

%global gnupg2_min_ver 2.2.24
%global libgpg_error_min_ver 1.36

Name:           gpgme
Summary:        GnuPG Made Easy - high level crypto API
Version:        1.18.0
Release:        %{anolis_release}%{?dist}

# MIT: src/cJSON.{c,h} (used by gpgme-json)
License:        LGPLv2+ and MIT
URL:            https://gnupg.org/related_software/gpgme/
Source0:        https://gnupg.org/ftp/gcrypt/gpgme/gpgme-%{version}.tar.bz2

Patch1000:      0001-fix-stupid-ax_python_devel.patch
Patch1001:	0002-don-t-add-extra-libraries-for-linking.patch

BuildRequires:  make
BuildRequires:  gcc
BuildRequires:  python3-distutils-extra
BuildRequires:  gcc-c++
BuildRequires:  gawk
BuildRequires:  gnupg2 >= %{gnupg2_min_ver}
BuildRequires:  gnupg2-smime
BuildRequires:  libgpg-error-devel >= %{libgpg_error_min_ver}
BuildRequires:  libassuan-devel >= 2.4.2

BuildRequires:  swig

BuildRequires:  chrpath

BuildRequires:  cmake

Requires:       gnupg2 >= %{gnupg2_min_ver}

%description
GnuPG Made Easy (GPGME) is a library designed to make access to GnuPG
easier for applications.  It provides a high-level crypto API for
encryption, decryption, signing, signature verification and key
management.

%package doc
Summary:	Doc files for %{name}
Requires:	%{name} = %{version}-%{release}
BuildArch:	noarch

%description doc
Doc files for %{name}

%package devel
Summary:        Development headers and libraries for %{name}
Requires:       %{name} = %{version}-%{release}

%description devel
%{summary}.

%package -n %{name}pp
Summary:        C++ bindings/wrapper for GPGME
Obsoletes:      gpgme-pp < 1.8.0-7
Provides:       gpgme-pp = %{version}-%{release}
Requires:       %{name} = %{version}-%{release}

%description -n %{name}pp
%{summary}.

%package -n %{name}pp-devel
Summary:        Development libraries and header files for %{name}-pp
Obsoletes:      gpgme-pp-devel < 1.8.0-7
Provides:       gpgme-pp-devel = %{version}-%{release}
Requires:       %{name}pp = %{version}-%{release}
Requires:       %{name}-devel = %{version}-%{release}

%description -n %{name}pp-devel
%{summary}

%package -n q%{name}
Summary:        Qt API bindings/wrapper for GPGME
Requires:       %{name}pp%{?_isa} = %{version}-%{release}
BuildRequires:  pkgconfig(Qt5Core)
BuildRequires:  pkgconfig(Qt5Test)

%description -n q%{name}
%{summary}.

%package -n q%{name}-devel
Summary:        Development libraries and header files for %{name}
Conflicts:      kdepimlibs-devel < 4.14.10-17
Requires:       q%{name} = %{version}-%{release}
Requires:       %{name}pp-devel
BuildRequires:  cmake

%description -n q%{name}-devel
%{summary}.

%package -n python3-gpg
Summary:        %{name} bindings for Python 3
%{?python_provide:%python_provide python3-gpg}
BuildRequires:  python3-devel
Requires:       %{name} = %{version}-%{release}
Obsoletes:      platform-python-gpg < %{version}-%{release}

%description -n python3-gpg
%{summary}.

%prep
%autosetup -p1

sed -i 's/3.8/%{python3_version}/g' configure

%build
export CFLAGS='%{optflags} -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64'
export CXXFLAGS='%{optflags} -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64'
export CFLAGS="$(echo ${CFLAGS} | tr '\n\\' '  ')"
export CXXFLAGS="$(echo ${CXXFLAGS} | tr '\n\\' '  ')"

%configure --disable-static --disable-silent-rules --enable-languages=cpp,qt,python
%make_build

%install
%make_install

rm -vf %{buildroot}%{python2_sitelib}/gpg/install_files.txt
rm -vf %{buildroot}%{python3_sitelib}/gpg/install_files.txt

%if %{with check}
%check
make check
%endif

%files
%license COPYING* LICENSES
%{_bindir}/%{name}-json
%{_libdir}/lib%{name}.so.11*

%files doc
%doc AUTHORS NEWS README*

%files devel
%{_bindir}/%{name}-config
%{_bindir}/%{name}-tool
%{_includedir}/%{name}.h
%{_libdir}/lib%{name}.so
%{_datadir}/aclocal/%{name}.m4
%{_infodir}/%{name}.info*
%{_libdir}/pkgconfig/%{name}*.pc

%files -n %{name}pp
%doc lang/cpp/README
%{_libdir}/lib%{name}pp.so.6*

%files -n %{name}pp-devel
%{_includedir}/%{name}++
%{_libdir}/lib%{name}pp.so
%{_libdir}/cmake/Gpgmepp

%files -n q%{name}
%doc lang/qt/README
%{_libdir}/libq%{name}.so.15*

%files -n q%{name}-devel
%{_includedir}/q%{name}
%{_includedir}/QGpgME/
%{_libdir}/libq%{name}.so
%{_libdir}/cmake/QGpgme/

%files -n python3-gpg
%doc lang/python/README
%{python3_sitearch}/gpg-*.egg-info
%{python3_sitearch}/gpg/

%changelog
* Tue Oct 11 2022 Funda Wang <fundawang@yeah.net> - 1.18.0-1
- New version 1.18.0
- Add patch from fedora for removal overlinking in gpgme-config

* Fri Mar 11 2022 liuzhilin <liuzhilin@uniontech.com> - 1.17.0-1
- Init for Anolis OS 23
- fix stupid-ax_python_devel
